//---------------------------------------------------------------------------
// http://radiohlam.ru
#ifndef Unit1H
#define Unit1H
#define BUFSIZE 1024
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <jpeg.hpp>
#include <math.h>
#include <Dialogs.hpp>
#include <Grids.hpp>
//---------------------------------------------------------------------------
  DCB    dcb;                   //  DCB
  HANDLE Port;                  //  
  OVERLAPPED ovr_wr, ovr_rd;
  AnsiString DataFilePath, ARegisterFilePath;

  unsigned char wr_buf[BUFSIZE], rd_buf[BUFSIZE]; //   
  unsigned char SelectedROM[8]; //  ROM  
  int  wr_buf_len, rd_buf_len, DevCounter, PageToUpdate;
  bool BS_FLAG;

  struct chip { AnsiString Name; int Model, Size, SizeSP;} SelectedChip;

bool WriteTo(void);
bool ReadFrom(void);
void OpenPort(void);
void ClosePort(void);
void BuidDataMemory(void);
void BuidSPMemory(void);
void LoadHexFile(void);
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key);
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TPanel *Panel1;
        TButton *Button1;
        TButton *Button2;
        TEdit *Edit1;
        TButton *Button3;
        TButton *Button4;
        TComboBox *ComboBox1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TRichEdit *RichEdit1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TRichEdit *RichEdit2;
        TRichEdit *RichEdit3;
        TImage *Image1;
        TOpenDialog *OpenDialog1;
        TMenuItem *Open1;
        TSaveDialog *SaveDialog1;
        TPanel *Panel2;
        TStaticText *StaticText1;
        TMenuItem *Saveas1;
        TMenuItem *Save1;
        TMenuItem *N4;
        TStringGrid *StringGrid1;
        TButton *Button5;
        TEdit *Edit2;
        TLabel *Label1;
        TPopupMenu *PopupMenu1;
        TMenuItem *Select1;
        TLabel *Label2;
        TEdit *Edit3;
        TButton *Button7;
        TLabel *Label3;
        TLabel *Label4;
        TRichEdit *RichEdit4;
        TLabel *Label6;
        TLabel *Label7;
        TRichEdit *RichEdit5;
        TLabel *Label9;
        TLabel *Label10;
        TRichEdit *RichEdit6;
        TButton *Button6;
        TEdit *Edit4;
        TEdit *Edit5;
        TLabel *Label5;
        TLabel *Label8;
        TEdit *Edit6;
        TLabel *Label11;
        TLabel *Label12;
        TEdit *Edit7;
        TButton *Button8;
        TMemo *Memo1;
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall RichEdit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall RichEdit1KeyPress(TObject *Sender, char &Key);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall Saveas1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall Select1Click(TObject *Sender);
        void __fastcall Button7Click(TObject *Sender);
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall Button8Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
